Eclipse Rich Ajax Platform

## org.eclipse.rwt
Class RWT

    java.lang.Object
      org.eclipse.rwt.RWT

    public final class RWT

extends java.lang.Object

This class provides access to aspects of RWT which are not part of the SWT API as RAP needs some additions regarding the server and client communication. It is responsible for providing access to the `ISessionStore` and the `HttpServletRequest`.

Since:
  1.0
See Also:
  `ILifeCycle`, `ISessionStore`, `IServiceStore`, `IApplicationStore`, `IBrowserHistory`, `IResourceManager`, `HttpServletRequest`, `HttpServletResponse`

Nested Class Summary
`static class` `RWT.NLS` This utility class helps to provide a similar approach for compile safe native language support than `NLS` does.

Field Summary
`static java.lang.String` `ACTIVE_KEYS` The property to use in `Display.setData()` in order to activate global key events for certain key sequences.
`static java.lang.String` `CANCEL_KEYS` The property to use in `Display.setData()` in order to always cancel the client's default operation associated with certain key sequences.
`static java.lang.String` `CUSTOM_ITEM_HEIGHT` The property to use in `Control.setData()` in order to set a custom item height.
`static java.lang.String` `DEFAULT_THEME_ID` The ID of the default theme.
`static java.lang.String` `FIXED_COLUMNS` Controls the number of fixed columns.
`static java.lang.String` `MARKUP_ENABLED` Controls whether the use of markup in text is enabled.

Method Summary
`static IApplicationStore` `getApplicationStore()` Returns the `IApplicationStore` instance that represents the web context's global data storage area.
`static IBrowserHistory` `getBrowserHistory()` Returns an instance if `IBrowserHistory` that provides support for the browser's history.
`static ILifeCycle` `getLifeCycle()` Returns the instance of the life cycle which is currently processed.
`static java.util.Locale` `getLocale()` Returns the preferred `Locale` that the client will accept content in.
`static HttpServletRequest` `getRequest()` Returns the `HttpServletRequest` that is currently processed.
`static IResourceManager` `getResourceManager()` Returns the instance of the currently available `IResourceManager`
`static HttpServletResponse` `getResponse()` Returns the `HttpServletResponse` that is mapped to the currently processed request.
`static IServiceManager` `getServiceManager()` Returns a manager to add and remove `IServiceHandler`s.
`static IServiceStore` `getServiceStore()` Returns the `IServiceStore` that is mapped to the currently processed request.
`static ISessionStore` `getSessionStore()` Returns the `ISessionStore` of the `HttpSession` to which the currently processed request belongs.
`static ISettingStore` `getSettingStore()` Returns the setting store instance for this session.
`static void` `requestThreadExec(java.lang.Runnable runnable)` Executes the run method of the given `runnable` on the request thread.
`static void` `setLocale(java.util.Locale locale)` Sets the preferred `Locale` that the client will accept content in to current session.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ACTIVE_KEYS

    public static final java.lang.String ACTIVE_KEYS

  The property to use in `Display.setData()` in order to activate global key events for certain key sequences. The value for this property has to be an array of Strings, each representing a key sequence. When this property is set on the display, the client will be instructed to issue events for the given key sequences. These key events can be captured using `Display.addFilter()`.

  The property can also be used in `Control.setData()`. In this case, a key listener that is attached to that control will only receive events for the specified key sequences. Control without active keys set will issue events for all key strokes.

  Valid strings for key sequences consist of one key and any number of modifier keys, separated by `+`. Keys can be identified by their character or by any of the keywords below. Special characters (not a letter or digit) should not be combined with any modifiers, and will issue events regardless of pressed modifiers.

  The following keywords can be used to refer to special keys: `BACKSPACE`, `TAB`, `RETURN`, `ENTER`, `ESCAPE`, `SPACE`, `PAGE_UP`, `PAGE_DOWN`, `END`, `HOME`, `ARROW_LEFT`, `ARROW_UP`, `ARROW_RIGHT`, `ARROW_DOWN`, `INSERT`, `DELETE`, `F1`, `F2`, `F3`, `F4`, `F5`, `F6`, `F7`, `F8`, `F9`, `F10`, `F11`, `F12`, Valid modifier keys are `SHIFT`, `ALT`, and `CTRL`.

  Examples: `"A"`, `"#"`, `"F12"`, `"CTRL+1"`, `"ALT+ARROW_DOWN"`, `"ALT+SHIFT+X"`.

  Example code for implementing a key binding: ``

       display.setData( RWT.ACTIVE_KEYS, new String[] { "CTRL+1", "CTRL+2" } );
       display.addFilter( SWT.KeyDown, new Listener() {
         public void handleEvent( Event event ) {
           boolean ctrlPressed = ( event.stateMask & SWT.Ctrl ) != 0;
           if( ctrlPressed && event.character == '1' ) {
             // handle Ctrl+1
           }
         }
       } );

  Since:
    1.4
  See Also:
    `Display.setData(String,Object)`, `Display.addFilter(int, Listener)`, `CANCEL_KEYS`, Constant Field Values

### CANCEL_KEYS

    public static final java.lang.String CANCEL_KEYS

  The property to use in `Display.setData()` in order to always cancel the client's default operation associated with certain key sequences. It allows the same values as `ACTIVE_KEYS`. If a key sequences is given in `CANCEL_KEYS` as well as in `ACTIVE_KEYS`, it will cancel its default operation, but still issue the event.

  The property can also be used in `Control.setData()`. In this case, the associated default operation will only be cancelled if the control is focused.

  Depending on the client, there may be certain keys that cannot be cancelled.

  Since:
    1.5
  See Also:
    `Display.setData(String,Object)`, `ACTIVE_KEYS`, Constant Field Values

### CUSTOM_ITEM_HEIGHT

    public static final java.lang.String CUSTOM_ITEM_HEIGHT

  The property to use in `Control.setData()` in order to set a custom item height. The custom item height must be specified as an `Integer` and passed to `setData()` with this constant as the key.

  For example: `table.setData( RWT.CUSTOM_ITEM_HEIGHT, new Integer( 45 ) );`

  Used By:

  - `Table`
  - `Tree`
  - `List`

  Since:
    1.5
  See Also:
    `Widget.setData(String,Object)`, Constant Field Values

### MARKUP_ENABLED

    public static final java.lang.String MARKUP_ENABLED

  Controls whether the use of markup in text is enabled. To enable markup in text, this constant must be passed to `setData()` with a value of `Boolean.TRUE`. The call to `setData()` must be placed directly after the control is created. Once, the markup in text is enabled it's not possible to disable it.

  For example: ``

         Table table = new Table( parent, SWT.NONE );
         table.setData( RWT.MARKUP_ENABLED, Boolean.TRUE );

  When markup is enabled, certain XHTML tags can be used in the text property of the respective widget. Specifying an unsupported element will lead to an `IllegalArgumentException` when setting the text. The following table lists the currently supported tags:

  <b>text</b>
    renders its content in bold font style
  <i>text</i>
    renders its content in italic font style
  <br/>
    inserts a line break
  <sub>
    renders its content as subscript
  <sup>
    renders its content as superscript
  <big>
    renders its content with bigger font size
  <small>
    renders its content with smaller font size
  <del>
    renders its content as deleted text
  <ins>
    renders its content as inserted text
  <em>
    renders its content as emphasized text
  <strong>
    renders its content as strong emphasized text
  <dfn>
    renders its content as instance definition
  <code>
    renders its content as computer code fragment
  <samp>
    renders its content as sample program output
  <kbd>
    renders its content as text to be entered by the user
  <var>
    renders its content as instance of a variable or program argument
  <cite>
    renders its content as citation
  <q>
    renders its content as short inline quotation
  <abbr>
    renders its content as abbreviation
  <span>
    generic style container
  <img>
    renders an image
  <a>
    renders a hyperlink
  The visual representation of the above tags can be specified in a `style` attribute.

  Used By:

  - `Table`
  - `Tree`
  - `List`
  - `Label`
  - `CLabel`

  Since:
    1.5
  See Also:
    `Widget.setData(String,Object)`, Constant Field Values

### FIXED_COLUMNS

    public static final java.lang.String FIXED_COLUMNS

  Controls the number of fixed columns. This constant must be passed to `setData()` together with an `Integer` object. The given number of columns, starting with the current leftmost one, will not scroll horizontally. The call to `setData()` must be placed directly after the control is created.

  For example: ``

         Table table = new Table( parent, SWT.NONE );
         table.setData( RWT.FIXED_COLUMNS, new Integer( 2 ) );

  Used By:
  - `Table`

  Since:
    1.5
  See Also:
    `Widget.setData(String,Object)`, Constant Field Values

### DEFAULT_THEME_ID

    public static final java.lang.String DEFAULT_THEME_ID

  The ID of the default theme. The default theme is the active theme if no custom theme has been specified. This ID can be used to register theme contributions to the default theme.

  Since:
    1.5
  See Also:
    `Application.addStyleSheet(String, String)`, Constant Field Values

Method Detail

### getLifeCycle

    public static ILifeCycle getLifeCycle()

  Returns the instance of the life cycle which is currently processed.

  Returns:
    instance of `ILifeCycle`

### getResourceManager

    public static IResourceManager getResourceManager()

  Returns the instance of the currently available `IResourceManager`

  Returns:
    instance of `IResourceManager`

### getServiceManager

    public static IServiceManager getServiceManager()

  Returns a manager to add and remove `IServiceHandler`s.

  Returns:
    the `IServiceManager`

### getSettingStore

    public static ISettingStore getSettingStore()

  Returns the setting store instance for this session.

  Returns:
    a `ISettingStore`; never `null`
  Since:
    1.1

### getServiceStore

    public static IServiceStore getServiceStore()

  Returns the `IServiceStore` that is mapped to the currently processed request.

  Returns:
    `IServiceStore`

### getSessionStore

    public static ISessionStore getSessionStore()

  Returns the `ISessionStore` of the `HttpSession` to which the currently processed request belongs.

  Returns:
    instance of `ISessionStore`

### getApplicationStore

    public static IApplicationStore getApplicationStore()

  Returns the `IApplicationStore` instance that represents the web context's global data storage area.

  Returns:
    instance of `IApplicationStore`
  Since:
    1.4

### getRequest

    public static HttpServletRequest getRequest()

  Returns the `HttpServletRequest` that is currently processed.

  Typical application code rarely needs to call this method. It is meant mainly for service handlers obtain parameters of the request to process.

  Returns:
    instance of `HttpServletRequest`
  See Also:
    `IServiceHandler`

### getResponse

    public static HttpServletResponse getResponse()

  Returns the `HttpServletResponse` that is mapped to the currently processed request.

  Typical application code never needs to call this method. It is meant only for service handlers to be able to write output and control other aspects of the response. Calling this method from a UI request (e.g. in an SWT event listener) is almost certainly an error.

  Returns:
    instance of `HttpServletResponse`
  See Also:
    `IServiceHandler`

### getLocale

    public static java.util.Locale getLocale()

  Returns the preferred `Locale` that the client will accept content in. This is either the `Locale` that was set in session-scope using the `setLocale(Locale)` method or the locale based on the `Accept-Language` HTTP header of the current request. If neither the `Locale` was set programmatically, nor the client request provides an `Accept-Language` header, this method returns the default locale for the server.

  Returns:
    the preferred `Locale` for the client.
  See Also:
    `setLocale(Locale)`

### setLocale

    public static void setLocale(java.util.Locale locale)

  Sets the preferred `Locale` that the client will accept content in to current session. The value set can be retrieved with the `getLocale()` method.

  See Also:
    `getLocale()`

### getBrowserHistory

    public static IBrowserHistory getBrowserHistory()

  Returns an instance if `IBrowserHistory` that provides support for the browser's history.

  Returns:
    the browser history support implementation
  Since:
    1.3
  See Also:
    `IBrowserHistory`

### requestThreadExec

    public static void requestThreadExec(java.lang.Runnable runnable)

  Executes the run method of the given `runnable` on the request thread. This method may only be called from the UI thread.

  NOTE: This API is provisional and may change without further notice.

  Parameters:
    `runnable` - the code to be executed on the request thread
  Throws:
    `SWTException` -
    - ERROR_THREAD_INVALID_ACCESS - if not called from the UI thread
  Since:
    1.3

Eclipse Rich Ajax Platform

Copyright (c) EclipseSource and others 2002, 2012. All rights reserved.